package cz.cvut.fel.alg;

/**
 * This class implements utility method used for binary search.
 *
 * @author Petr Ryšavý, Karel Horák
 */
public final class BinarySearch {

    /**
     * Do not let anybody to instantiate this class.
     */
    private BinarySearch() {
    }

    /**
     * Finds the given key in the array. This method runs in O(log(n)) and
     * implements binary search.
     *
     * @param array The array to search. Must be sorted.
     * @param value The value to sarch.
     * @return The index of {@code value} in {@code array} or {@code -1} if the
     * value is not present.
     */
    public static int binarySearch(int[] array, int value) {
        // TODO insert method body
        // throw new UnsupportedOperationException("Not implemented yet.");
        return binarySearch(array, value, 0, array.length);
    }

    private static int binarySearch(int[] array, int value, int begin, int end) {
        if(begin >= end) return -1;
        else {
            int middle = begin + (end - begin)/2;

            if(array[middle] == value) return middle;
            else if(array[middle] > value) return binarySearch(array, value, begin, middle);
            else return binarySearch(array, value, middle+1, end);
        }
    }
}
