package cz.cvut.fel.alg;

import org.junit.runner.JUnitCore;
import org.junit.runner.Result;
import org.junit.runner.notification.Failure;

/**
 * This class tests the binary search tree against test classes. To run tests in
 * NetBeans press shift+F6 or go to test classes and use the same shortcut.
 *
 * @author Petr Ryšavý, Karel Horák
 */
public class Main {
    private static final JUnitCore junit = new JUnitCore();

    public static void main(String[] args) {
        runTest(SimpleTreeTest.class, "SimpleTreeTest");
        runTest(RandomTreeTest.class, "RandomTreeTest");
        runTest(BinarySearchTest.class, "Binární vyhledávání");
        runTest(SimpleBSTTest.class, "BST");
        runTest(IsAVLTest.class, "isAVL");
    }

    private static void runTest(Class testClass, String comment) {
        Result result = junit.run(testClass);
        System.out.println("--------------------------------------");
        System.out.println(comment);
        System.out.println("Nefunkčních " + result.getFailureCount() + " z " + result.getRunCount());
        if (result.getFailureCount() != 0) {
            System.out.println("Chyby:");
            for (Failure f : result.getFailures())
                System.out.printf("    %-30s %s\n", f.getDescription().getMethodName(), f.getMessage());
        }
    }

}
